﻿package
{
	import flash.display.Sprite;
	import flash.geom.Rectangle;
	import flashx.textLayout.factory.StringTextLineFactory;
	import flashx.textLayout.formats.TextLayoutFormat;
	import flashx.textLayout.formats.TextAlign;
	import flash.text.engine.TextLine;
	
	/**
	 * ...
	 * @author agj
	 */
	public class Label extends Sprite
	{
		
		private var _text:String;
		private var _textLine:TextLine;
		private var _format:TextLayoutFormat;
		private var _factory:StringTextLineFactory;
		private var _width:Number;
		private var _height:Number;
		
		public function Label(textString:String, widthValue:Number, heightValue:Number) 
		{
			_factory = new StringTextLineFactory;
			_text = textString;
			_width = widthValue;
			_height = heightValue;
			
			_redrawTextLine();
		}
		
		public function set text(textString:String):void {
			_text = textString;
			_redrawTextLine();
		}
		public function get text():String {
			return _text;
		}
		
		public function set format(newFormat:TextLayoutFormat):void {
			_format = newFormat;
			_redrawTextLine();
		}
		public function get format():TextLayoutFormat {
			return _format;
		}
		
		public override function set width(widthValue:Number):void {
			_width = widthValue;
			_redrawTextLine();
		}
		public override function get width():Number {
			return _width;
		}
		public override function set height(widthValue:Number):void {
			_height = widthValue;
			_redrawTextLine();
		}
		public override function get height():Number {
			return _height;
		}
		
		public function get textWidth():Number {
			return _textLine.textWidth;
		}
		public function get textHeight():Number {
			return _textLine.ascent;
		}
		
		private function _redrawTextLine():void {
			if (_textLine) {
				_textLine.parent.removeChild(_textLine);
				_textLine = null;
			}
			
			_factory.compositionBounds = new Rectangle(0, 0, _width, _height);
			_factory.text = _text;
			
			_factory.spanFormat = _format;
			
			_factory.createTextLines(_useTextLines);
		}
		private function _useTextLines(line:TextLine):void {
			_textLine = line;
			line.y -= line.ascent
			addChild(line);
			
			if (_format) if (_format.textAlign) {
				if (_format.textAlign == TextAlign.RIGHT) line.x = -line.textWidth;
				else if (_format.textAlign == TextAlign.CENTER) line.x = -(line.textWidth / 2);
			}
		}
		
	}
	
}